#include "TcpFlow.h"
#define ARGS 3


int main(int argc, char *argv[]){
  int sockfd, newsockfd, client_len, numbytes, port, secs, rem, select, times;
  struct sockaddr_in server_addr, client_addr;
  char buf[MAXDATASIZE]; 	
  double start_time, stop_time, total_time, throughput, total_bytes, numpackets;
  FILE *f;
  char file_name[20];
  int sleeped = 0;
		
  if(argc <= ARGS){
    printf("use %s <Port> <secs> <times>\n", argv[0]);
    return -1;
  }
	
  port = atoi(argv[1]);
  secs = atoi(argv[2]);
  times = atoi(argv[3]);

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("Server: can't open stream socket\n");
    exit(-1);
  }
	
  bzero((char *) &server_addr, sizeof(server_addr));
  server_addr.sin_family = AF_INET;		 
  server_addr.sin_port = htons(port);	
  server_addr.sin_addr.s_addr = htonl(INADDR_ANY); 
	
  while (bind(sockfd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
    //printf("Bind error\n");
    //perror("Bind:");
    sleep(1);
    if(sleeped++ >= 9) {
      printf("No client connection in %d secs. Bind error\n", secs);
      exit(-1);
    }
  }
	
  if(listen(sockfd, MAX_CONNECTIONS) < 0){
    printf("No client connection in %d secs. Listen error\n", secs);
    perror("Listen");
    exit(-1);
  }

  select=input_timeout(sockfd, secs);
  sprintf(file_name, "tiempos_%d.txt", port);
  if (times) f = fopen(file_name,"w");
	
  if (select==1){
    numpackets=-1;
    total_bytes = 0;
    client_len = sizeof(client_addr);
    if((newsockfd = accept(sockfd, (struct sockaddr *) &client_addr,(socklen_t *) &client_len)) < 0) {
      perror("Accept");
      printf("Accept Error\n");
      close(sockfd);
      exit(-1);
    }	
    close(sockfd);

    start_time=return_time();	
    numbytes = 1;
    rem = secs;
    while(numbytes > 0 && input_timeout(newsockfd, rem)== 1) {
      if((numbytes=recv(newsockfd, buf, MAXBUFFER, 0)) < 0){
	printf("No client connection in %d secs. Receive error\n", secs);
	perror("Receive");
	stop_time = return_time();
	total_time = (stop_time - start_time);
	rem = secs - (int)total_time;
	continue;
      }
      numpackets++;
      if(numbytes>0){
	total_bytes = total_bytes + numbytes;
	buf[numbytes]='\0';
	if (times)fprintf(f,"%f\n",return_time());
      }
      stop_time = return_time();
      total_time = (stop_time - start_time);
      rem = secs - (int)total_time;
    }
    close(newsockfd);
    stop_time = return_time();
    total_time = (stop_time - start_time);
    throughput = (total_bytes *8)/(total_time * 1024);
    printf("Received: %.0f packets. Size: %.0f bytes. Time: %.3lf seconds. Throughput: %.3f Kb/s\n", numpackets, total_bytes, total_time, throughput);
    if (times)fclose(f);
    return 0;
		
  }
  printf("No client connection in %d secs\n", secs);
	
  close(sockfd);
  return 0;
}

