#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>

#define PORT 24000
#define MAX_CONNECTIONS 255
#define NTRYOUTS 100

int main(int argc, char* argv[]) {
  //Both
  int iterator;
  char * message = "Start!!";

  //Master
  int noc; //Number of clients
  int *soc; //Sockets of clients
  int ssock, csock; //Server and client socket
  struct sockaddr_in server_addr; //My address
  struct sockaddr_in client_addr;//Client dir
  int clength; //Client length
  int on = 1; //For Reuseaddr

  //Client
  struct sockaddr_in server; //Server address
  struct hostent *he; //IP direction
  char received[255];
  int receivedSize;
  int tryouts = 0;

  if(argc != 3) {
    printf("Usage: %s [-c/-m] <IP of master/number of clients to wait>\n", argv[0]);
    return 0;
  }

  if(strcmp(argv[1], "-c") == 0) {
    //Client
    
    if((he = gethostbyname(argv[2])) == NULL) {
      printf("Client: Hostname FAIL\n");
      return -1;
    }

    if((ssock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      printf("Client: Socket creation FAIL\n");
      return -1;
    }

    bzero((char *) &server, sizeof(server));
    server.sin_family = AF_INET;
    server.sin_addr = *((struct in_addr *)he->h_addr);
    server.sin_port = htons(PORT);

    while(connect(ssock, (struct sockaddr *) &server, sizeof(server)) < 0) {
      if(tryouts++ > NTRYOUTS) {
	printf("Client: Connect FAIL\n");
	return -1;
      }else{
	sleep(1);
      }
    }

    printf("Connected\n");

    //Receive until we receive "Message"
    while((receivedSize = recv(ssock, received, 255,0)) && strcmp(received, message) != 0);
    
    printf("Bye-bye\n");

    close(ssock);
    return 0;
  }


  if(strcmp(argv[1], "-m") == 0) {
    //Master
    noc = atoi(argv[2]);

    soc = (int *)malloc((noc+1) * sizeof(int));

    //Opening socket
    if((ssock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      printf("Server: Socket creation FAIL");
      return -1;
    }

    //Filling socket
    bzero((char *) &server_addr, sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_port = htons(PORT);
    server_addr.sin_addr.s_addr = htonl(INADDR_ANY);

    if(setsockopt(ssock, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0) {
      printf("Server: Socket REUSEADDR FAIL");
    }

    //Binding socket to a port
    if(bind(ssock, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
      printf("Server: Socket binding FAIL");
      return -1;
    }

    if(listen(ssock, MAX_CONNECTIONS) < 0) {
      printf("Server: Listen FAIL");
      return -1;
    }

    for(iterator = 0; iterator < noc; iterator++) {
      //Wait for all clients
      clength = sizeof(client_addr);
      csock = accept(ssock, (struct sockaddr *)&client_addr , &clength);
      if(csock < 0) {
	printf("Server: Accept FAIL\n");
	return -1;
      }
      printf("%d clients connected- %d left\n", iterator +1 , noc - (iterator+1));
      soc[iterator] = csock;
      
    }

    for (iterator = 0; iterator < noc; iterator ++) {
      //Wakeup all clients
      
      send(soc[iterator], message, strlen(message),0);

      close(soc[iterator]);
    }
    close(ssock);

    printf("Bye-bye\n");
    //Bye-bye
    return 0;
  }
  
  
  
  printf("Usage: %s [-c/-m] <IP of master/number of clients to wait>\n", argv[0]);
  return 0;
  
}
