/* UDP client in the internet domain */
#include "UdpFlow.h"
#include "dacme.h"

#define ARGS 9
#define ADJUST_TIME 20000000
#define ADJUST 200
#define SLOTS 18
#define ONE_SEC 1000000

 int seconds_elapsed(struct timeval *time_uno,struct timeval *time_orig) {
 double aux;
 double aux2;
 
    aux = time_uno->tv_sec - time_orig->tv_sec;
    aux2 = time_uno->tv_usec - time_orig->tv_usec;
    
    aux = aux + (aux2/ONE_SEC);
    
    return (int)aux;
 }

int main(int argc, char *argv[]){
  int sock, length, n, numbytes, secs, i, packets_sended, aux;
  struct sockaddr_in server, from;
  struct timeval time_uno;
  struct timeval time_dos;
  struct timeval time_orig;
  struct hostent *hp;
  char buffer[256];
  unsigned char cat, cataux;
  char *message;
  float real_waiting_time, dummy_operation;
  float packets_slots, piece_packets, remaining_packets;
  double time1,time2, adjust_time;
  unsigned int time_per_packet, pckts, catauxl;
  struct timespec time_sleep, rem;   
  dacme_flow f;
  int bitrate, delay;
  int dacme, category;
  int sec_ant = 0;
  int secs_elapsed = 0;
  int packets_sended_second = 0;
  int mandados;

  if(argc != ARGS){	
    printf("N Args = %d - use %s <IP> <Port> <Bytes/Pckt> <packets s> <delay> <Category> <secs> <Dacme>\n",argc, argv[0]);
    return -1;
  }
	
  numbytes =  atoi(argv[3]);
  pckts = atoi(argv[4]);
  delay = atoi(argv[5]);
  category = atoi(argv[6]);  
  secs = atoi(argv[7]);
#ifdef DEBUG
  printf("Segundos de envio = %d\n", secs);
#endif
  dacme = atoi(argv[8]);
  
  if(category < 0 || category > 3) error("Category");
  
  //pckts = (int)(((double)(bitrate * 1000.0) / (double)(numbytes * 8.0)) +0.5);
  //pckts = atoi(argv[4]);
  bitrate = (int)(((numbytes * 8 * pckts)/(1000.0))+0.5);

#ifdef DEBUG
  printf("Packets per sec = %d\n", pckts);
#endif

  if ((hp=gethostbyname(argv[1])) == NULL) error("Name resolution error");

  server.sin_family = AF_INET;
  server.sin_port = htons(atoi(argv[2]));	
  server.sin_addr = *((struct in_addr *)hp->h_addr); 

  if(dacme == 0) {
#ifdef DEBUG
    printf("NO DACME\n");
#endif
    sock = socket(AF_INET,SOCK_DGRAM,0);
  
    if(sock < 0) {
      error("Socket");
    }
    //getsockopt(sock, IPPROTO_IP, IP_TOS,&cataux,&catauxl);
    switch(category) {
    case 0:
      cat = 0x0;
      break;
    case 1:
      cat = 0x08;
      break;
    case 2:
      cat = 0x28;
      break;    
    case 3:
      cat = 0x30;
      break;
    default:
      cat = 0x0;
    }
    cat = cat << 2;
    //    cat = cataux | cat;
    setsockopt(sock, IPPROTO_IP, IP_TOS, &cat, sizeof(cat));
  }
  else {
    //bitrate = (pckts*numbytes*8)/1000;
    init_flow(&f);
    f.port = atoi(argv[2]);
    f.category = category;
    f.bitrate = bitrate;
    f.delay = delay;
    f.packet_size = numbytes;
    strcpy(f.ip,argv[1]);
    
#ifdef DEBUG
    printf("DACME\nbitrate = %d\n", bitrate);
#endif
    if((sock= dacme_socket(&f)) < 0) error("Socket Dacme");
  }
  
  length=sizeof(struct sockaddr_in);
  message = (char *)malloc(sizeof(char)*numbytes+32);
  
  printf("Nueva version 1\n"); 
 time_sleep.tv_nsec = (ONE_SEC*1000)/pckts;
  if(time_sleep.tv_nsec <= ADJUST_TIME) {
    time_sleep.tv_nsec = 0;
    printf("Sleep nsec = %ld\n", time_sleep.tv_nsec);
  }else{
    time_sleep.tv_nsec -= ADJUST_TIME;
    printf("Sleep nsec = %ld\n", time_sleep.tv_nsec);
  }
  time_sleep.tv_sec = 0;
  for(i = 0; i < numbytes+32; i++ )
    message[i] = (i % 27)+'a';
  
  gettimeofday(&time_orig,NULL);
  gettimeofday(&time_dos,NULL);
  aux = sprintf(message, "%15u %15u ", (unsigned int)time_dos.tv_sec,(unsigned int) time_dos.tv_usec);
  
  packets_sended = 0;
  packets_sended_second = 0;  
  while(secs_elapsed < secs){
    
    message[numbytes+31]='\0';	

    while(packets_sended_second < pckts) {
      gettimeofday(&time_dos,NULL);
      aux = sprintf(message, "%u %u ", (unsigned int)time_dos.tv_sec,(unsigned int) time_dos.tv_usec);
      
      mandados = sendto(sock,&message[0], numbytes,0,(struct sockaddr *)&server,length);
      if(mandados != numbytes) {
	printf("Error mandando, %d\n", mandados);
      }
      packets_sended_second++;

      //To send needed packets each second if needed
      secs_elapsed = seconds_elapsed(&time_dos, &time_orig);
      if(secs_elapsed > sec_ant) {
	gettimeofday(&time_dos,NULL);
	aux = sprintf(message, "%15u %15u ", (unsigned int)time_dos.tv_sec,(unsigned int) time_dos.tv_usec);
	while(packets_sended_second < pckts ) {
	  sendto(sock,&message[0], numbytes ,0,(struct sockaddr *)&server,length);
	  packets_sended_second++;
	}
      }else{
	if(time_sleep.tv_nsec > 0)
	  nanosleep(&time_sleep, &rem);
      }    
    }
    packets_sended += packets_sended_second;

    gettimeofday(&time_uno,NULL);
    secs_elapsed = seconds_elapsed(&time_uno, &time_orig);
    
    if(secs_elapsed > sec_ant) {
      sec_ant = secs_elapsed;
      packets_sended_second=0;
    }

  }
  if(dacme == 0)
    close(sock);
  else
    dacme_release(&f, sock);
#ifdef DEBUG
  printf("Packets sended %d\n",packets_sended);
#endif
  return 0;
}
