/* Creates a datagram server.  The port 
   number is passed as an argument.  This
   server runs forever */

#include "UdpFlow.h"
#define ARGS 4
#define MAX_BUFFER 1500

int main(int argc, char *argv[]){
  int sock, length, fromlen, n, port, secs, select, times;
  int i;
  unsigned int num = 0;
  struct sockaddr_in server;
  struct sockaddr_in from;
  char buf[MAX_BUFFER];
  int first_packet=0;
  double start_time, stop_time, total_time, throughput, total_bytes, execution_time, last_iteration_time;
  FILE *f;
  char file_name[20];
  double tiempo_salida;
  struct timeval t_llegada;
  unsigned int segundos, usegundos;
  double delay;
  double acum_delay = 0.0;

  double aux1, aux2;
  
  if(argc <= ARGS){
    printf("use %s <Port> <waiting secs> <receiving seconds> <times>\n", argv[0]);
    return -1;
  }
  
  port = atoi(argv[1]);
  secs = atoi(argv[2]);
  total_time = atoi(argv[3]);
  times = atoi(argv[4]);
  
  if ((sock=socket(AF_INET, SOCK_DGRAM, 0)) <0) error("Socket");
  
  length = sizeof(server);
  bzero(&server,length);
  server.sin_family=AF_INET;
  server.sin_addr.s_addr=INADDR_ANY;
  server.sin_port=htons(port);
  
  if (bind(sock,(struct sockaddr *)&server,length)<0) error("Bind");
  
  fromlen = sizeof(struct sockaddr_in);
  
  if(times) {
    sprintf(file_name, "times_%d.txt", port);
    f = fopen(file_name,"w");

    gettimeofday(&t_llegada,NULL);
    stop_time = t_llegada.tv_sec + t_llegada.tv_usec/1000000.0;
    fprintf(f,"%f %f %d %f\n",0.0, stop_time, 0, 0.0);
  }
  
  select=input_timeout(sock, secs);
  total_time++; //One extra second to receive "slow" last packets
  if (select==1){
    start_time=return_time();
    //    fprintf(f, "%f\n", start_time);
    while (input_timeout(sock, total_time - (int)(return_time() - start_time))!=0) {

      if((n = recvfrom(sock,buf,sizeof(buf),0,(struct sockaddr *)&from,&fromlen)) <0) error("Recvfrom");

      num++;
#ifdef DELAY
      gettimeofday(&t_llegada,NULL);
      sscanf(buf, "%u%u", &segundos, &usegundos);
      
      aux1 = (double)t_llegada.tv_sec - (double)segundos;
      aux2 = (double) t_llegada.tv_usec - (double)usegundos;
      aux2 = aux2 / 1000000.0;
      delay = aux1 + aux2;
      //      delay = (double)((double)(t_llegada.tv_sec - segundos)+((double)((unsigned long int)t_llegada.tv_usec - (unsigned long int)usegundos)/1000000.0));
#endif
#ifdef DEBUG
      if(delay > 1.0) {
	fprintf(f, "--> %u.%u - %u.%u = %.3f\n", t_llegada.tv_sec, t_llegada.tv_usec, segundos, usegundos, delay);
	fprintf(f, "---> %u + %u/1000000.0 = + %.3f\n", t_llegada.tv_sec - segundos, t_llegada.tv_usec - usegundos, (double)(t_llegada.tv_usec - usegundos)/1000000.0);
      }
#endif
#ifdef DELAY
      stop_time = t_llegada.tv_sec + t_llegada.tv_usec/1000000.0;
      acum_delay += delay;
#endif
      if(times) { 
#ifdef IDA_Y_VUELTA
	fprintf(f,"%f %f \n",((stop_time - tiempo_salida)/2.0), stop_time - start_time);
#else
	fprintf(f,"%f %f %d %f\n",delay, stop_time, n, acum_delay);
#endif
      }
    }
    total_bytes = n*num;
    throughput=(total_bytes*8)/((--total_time)*1000.0);
#ifdef DELAY
    acum_delay= acum_delay/(double)num;
#else
    acum_delay = 0.0;
#endif
    printf("Received: %u packets. Size: %.0f bytes. Time: %.3lf seconds. Throughput: %.3f Kb/s. Delay: %.3f ms\n", num, total_bytes, total_time, throughput,acum_delay*1000.0);
  }else{
    printf("No client connection in %d secs.\n", secs);
  }
  close(sock);

  if(times) {
    gettimeofday(&t_llegada,NULL);
    stop_time = t_llegada.tv_sec + t_llegada.tv_usec/1000000.0;
    fprintf(f,"%f %f %d %f\n",0.0, stop_time, 0, 0.0);
    fclose(f);
  }
  
  exit(0);
}

