/*
 * ComputerWindow.java
 *
 * Created on 11 de mayo de 2006, 8:53
 */

package castadiva_gui;

import castadiva.*;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.net.*;
import java.util.*;
import java.io.*;
import java.lang.*;

/**
 *
 * @author  jorge
 *
 */
public class ComputerGUI extends javax.swing.JFrame {    
    CastadivaModel m_model;
    /**
     * Creates new form ComputerWindow
     */
    public ComputerGUI(CastadivaModel model) {
        Enumeration dispositivos = null;
        String elemento;
        String[] mostrar, cacho;
        
        m_model = model;
        initComponents();
        setLocation((int)Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2-(int)(this.getWidth()/2), (int)Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2-(int)(this.getHeight()/2));
        
        
        //Show all ethernet devices in the m_model.computer.
        try {
            dispositivos = NetworkInterface.getNetworkInterfaces();
        } catch (SocketException ex) {
            ex.printStackTrace();
        }
        while(dispositivos.hasMoreElements()){
            InterfacesComboBox.addItem(m_model.computer.TranslateInterfaceToString(dispositivos.nextElement().toString()));
        }
        if (m_model.computer.WhatInterface() != null)
            InterfacesComboBox.setSelectedItem(m_model.computer.WhatInterfaceString());
        else
            InterfacesComboBox.setSelectedIndex(-1);
        
    }
    
    /**
     * @author Wannes
     * The following function allows to update the textFields when their value is changed otherwise than trough this GUI.
     * Note : It seems that the interface option is not used in Castadiva ?
     * /TODO Maybe remove the interface ComboBox if it is not for further use.
     */
    public void GUIReady()
    {
        this.WorkingDirectoryTextField.setText(m_model.WhatComputerWorkingDirectory());
        this.InterfacesComboBox.setSelectedItem(m_model.computer.WhatInterfaceString());
    }
    

    public String ReturnSelectedInterface(){
        return InterfacesComboBox.getSelectedItem().toString();
    }
    
    public String ReturnTheWorkingDirectory(){
        return WorkingDirectoryTextField.getText();
    }
    
    public void addCloseButtonListener(ActionListener al){
        CloseButton.addActionListener(al);
    }

    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ButtonPanel = new javax.swing.JPanel();
        CloseButton = new javax.swing.JButton();
        NFSPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        WorkingDirectoryTextField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        NetPanel = new javax.swing.JPanel();
        InterfacesComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();

        setTitle("Computer configuration");
        setResizable(false);

        ButtonPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        CloseButton.setText("Close");

        org.jdesktop.layout.GroupLayout ButtonPanelLayout = new org.jdesktop.layout.GroupLayout(ButtonPanel);
        ButtonPanel.setLayout(ButtonPanelLayout);
        ButtonPanelLayout.setHorizontalGroup(
            ButtonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, ButtonPanelLayout.createSequentialGroup()
                .addContainerGap(139, Short.MAX_VALUE)
                .add(CloseButton)
                .addContainerGap())
        );
        ButtonPanelLayout.setVerticalGroup(
            ButtonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(ButtonPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(CloseButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        NFSPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel2.setText("Working directory (NFS):");

        WorkingDirectoryTextField.setText(m_model.WhatComputerWorkingDirectory());

        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel5.setText("?");
        jLabel5.setToolTipText("Remember to allow Castadiva to modify this directory.");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jLabel5)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jLabel5)
        );

        org.jdesktop.layout.GroupLayout NFSPanelLayout = new org.jdesktop.layout.GroupLayout(NFSPanel);
        NFSPanel.setLayout(NFSPanelLayout);
        NFSPanelLayout.setHorizontalGroup(
            NFSPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(NFSPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(NFSPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(NFSPanelLayout.createSequentialGroup()
                        .add(WorkingDirectoryTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 157, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jLabel2))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        NFSPanelLayout.setVerticalGroup(
            NFSPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(NFSPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(NFSPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(NFSPanelLayout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(WorkingDirectoryTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        NetPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setText("Net device:");

        org.jdesktop.layout.GroupLayout NetPanelLayout = new org.jdesktop.layout.GroupLayout(NetPanel);
        NetPanel.setLayout(NetPanelLayout);
        NetPanelLayout.setHorizontalGroup(
            NetPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(NetPanelLayout.createSequentialGroup()
                .add(NetPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(NetPanelLayout.createSequentialGroup()
                        .add(22, 22, 22)
                        .add(jLabel1))
                    .add(NetPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(InterfacesComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        NetPanelLayout.setVerticalGroup(
            NetPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, NetPanelLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(InterfacesComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jLabel1.getAccessibleContext().setAccessibleName("Dirección de Red:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, ButtonPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, NetPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, NFSPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(NetPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(NFSPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ButtonPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(13, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel ButtonPanel;
    private javax.swing.JButton CloseButton;
    private javax.swing.JComboBox InterfacesComboBox;
    private javax.swing.JPanel NFSPanel;
    private javax.swing.JPanel NetPanel;
    private javax.swing.JTextField WorkingDirectoryTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
